function do_henon()

tolerance = evalin('base', 'tolerance');
max_step = evalin('base', 'max_step');
arc_length = 50;
d = evalin('base', 'd');
a_min = evalin('base', 'a_min');
a_max = evalin('base', 'a_max');
Da_min = evalin('base', 'Da_min');
Da_max = evalin('base', 'Da_max');
D_min = evalin('base', 'D_min');
cB = evalin('base', 'cB');
eB = evalin('base', 'eB');
diverge = evalin('base', 'diverge');




param = {1.9, 0.3};
xF = find_periodic_md(@henon, 1, [-2 2; -2 2], [5 5], tolerance, diverge, max_step, false, param{:});
points = period_classify(@henon, xF, 1, 1e-6, param{:});
pm = xF(1, :);
pp = xF(2, :);
[upp1, arc] = sc_unstable(@henon, pp, arc_length, d, a_min, a_max, Da_min, Da_max, D_min, cB, diverge, param{:});
[upp2, arc] = sc_unstable(@henon, pp, arc_length, -d, a_min, a_max, Da_min, Da_max, D_min, cB, diverge, param{:});
[spp1, arc] = sc_stable(@henon, pp, arc_length, 2, d, a_min, a_max, Da_min, Da_max, D_min, eB, diverge, param{:});
[spp2, arc] = sc_stable(@henon, pp, arc_length, 2, -d, a_min, a_max, Da_min, Da_max, D_min, eB, diverge, param{:});
hfig = plot_manifolds(points, {upp1, upp2}, {spp1, spp2});

param = {1.95, 0.3};
xF = find_periodic_md(@henon, 1, [-2 2; -2 2], [5 5], tolerance, diverge, max_step, false, param{:});
points = period_classify(@henon, xF, 1, 1e-6, param{:});
pm = xF(1, :);
pp = xF(2, :);
[upp1, arc] = sc_unstable(@henon, pp, arc_length, d, a_min, a_max, Da_min, Da_max, D_min, cB, diverge, param{:});
[upp2, arc] = sc_unstable(@henon, pp, arc_length, -d, a_min, a_max, Da_min, Da_max, D_min, cB, diverge, param{:});
[spp1, arc] = sc_stable(@henon, pp, arc_length, 2, d, a_min, a_max, Da_min, Da_max, D_min, eB, diverge, param{:});
[spp2, arc] = sc_stable(@henon, pp, arc_length, 2, -d, a_min, a_max, Da_min, Da_max, D_min, eB, diverge, param{:});
hfig = plot_manifolds(points, {upp1, upp2}, {spp1, spp2});

param = {2, 0.3};
xF = find_periodic_md(@henon, 1, [-2 2; -2 2], [5 5], tolerance, diverge, max_step, false, param{:});
points = period_classify(@henon, xF, 1, 1e-6, param{:});
pm = xF(1, :);
pp = xF(2, :);
[upp1, arc] = sc_unstable(@henon, pp, arc_length, d, a_min, a_max, Da_min, Da_max, D_min, cB, diverge, param{:});
[upp2, arc] = sc_unstable(@henon, pp, arc_length, -d, a_min, a_max, Da_min, Da_max, D_min, cB, diverge, param{:});
[spp1, arc] = sc_stable(@henon, pp, arc_length, 2, d, a_min, a_max, Da_min, Da_max, D_min, eB, diverge, param{:});
[spp2, arc] = sc_stable(@henon, pp, arc_length, 2, -d, a_min, a_max, Da_min, Da_max, D_min, eB, diverge, param{:});
hfig = plot_manifolds(points, {upp1, upp2}, {spp1, spp2});

param = {2.1, 0.3};
xF = find_periodic_md(@henon, 1, [-2 2; -2 2], [5 5], tolerance, diverge, max_step, false, param{:});
points = period_classify(@henon, xF, 1, 1e-6, param{:});
pm = xF(1, :);
pp = xF(2, :);
[upp1, arc] = sc_unstable(@henon, pp, arc_length, d, a_min, a_max, Da_min, Da_max, D_min, cB, diverge, param{:});
[upp2, arc] = sc_unstable(@henon, pp, arc_length, -d, a_min, a_max, Da_min, Da_max, D_min, cB, diverge, param{:});
[spp1, arc] = sc_stable(@henon, pp, arc_length, 2, d, a_min, a_max, Da_min, Da_max, D_min, eB, diverge, param{:});
[spp2, arc] = sc_stable(@henon, pp, arc_length, 2, -d, a_min, a_max, Da_min, Da_max, D_min, eB, diverge, param{:});
hfig = plot_manifolds(points, {upp1, upp2}, {spp1, spp2});



% num = 1000;
% len = 0.5;
% 
% hfig = plot_manifolds(points, {upp1, upp2}, {spp1, spp2});
% hold on;
% 
% sideA = zeros(2, num);
% sideB = zeros(2, num);
% sideC = zeros(2, num);
% sideD = zeros(2, num);
% henon_J(pp, param{:});
% [v, l] = eig(henon_J(pp, param{:}));
% u_vec = v(:, 1);
% s_vec = v(:, 2);
% sideA(:, 1) = pp + u_vec'.*(-len/2) + s_vec'.*(len/2);
% sideB(:, 1) = pp + u_vec'.*(len/2) + s_vec'.*(len/2);
% sideC(:, 1) = pp + u_vec'.*(-len/2) + s_vec'.*(-len/2);
% sideD(:, 1) = pp + u_vec'.*(-len/2) + s_vec'.*(len/2);
% for i = 2:num
%     sideA(:, i) = sideA(:, i-1) + u_vec.*(len/num);
%     sideB(:, i) = sideB(:, i-1) + s_vec.*(-len/num);
%     sideC(:, i) = sideC(:, i-1) + u_vec.*(len/num);
%     sideD(:, i) = sideD(:, i-1) + s_vec.*(-len/num);
% end;
% 
% plot(sideA(1, :), sideA(2, :), '-k');
% plot(sideB(1, :), sideB(2, :), '-k');
% plot(sideC(1, :), sideC(2, :), '-k');
% plot(sideD(1, :), sideD(2, :), '-k');
% 
% % image
% sideAi = sideA;
% sideBi = sideB;
% sideCi = sideC;
% sideDi = sideD;
% 
% L = 4
% for j = 1:L
%     for i = 1:num
%         sideAi(:, i) = henon(sideAi(:, i), param{:});
%         sideBi(:, i) = henon(sideBi(:, i), param{:});
%         sideCi(:, i) = henon(sideCi(:, i), param{:});
%         sideDi(:, i) = henon(sideDi(:, i), param{:});
%     end; 
% end;
% 
% plot(sideAi(1, :), sideAi(2, :), '-g', 'LineWidth', 2);
% plot(sideBi(1, :), sideBi(2, :), '-g', 'LineWidth', 2);
% plot(sideCi(1, :), sideCi(2, :), '-g', 'LineWidth', 2);
% plot(sideDi(1, :), sideDi(2, :), '-g', 'LineWidth', 2);
% 
% % preimage
% sideAp = sideA;
% sideBp = sideB;
% sideCp = sideC;
% sideDp = sideD;
% 
% K = 2
% for j = 1:K
%     for i = 1:num
%         sideAp(:, i) = henon_inv(sideAp(:, i), param{:});
%         sideBp(:, i) = henon_inv(sideBp(:, i), param{:});
%         sideCp(:, i) = henon_inv(sideCp(:, i), param{:});
%         sideDp(:, i) = henon_inv(sideDp(:, i), param{:});
%     end; 
% end;
% 
% plot(sideAp(1, :), sideAp(2, :), '-g', 'LineWidth', 2);
% plot(sideBp(1, :), sideBp(2, :), '-g', 'LineWidth', 2);
% plot(sideCp(1, :), sideCp(2, :), '-g', 'LineWidth', 2);
% plot(sideDp(1, :), sideDp(2, :), '-g', 'LineWidth', 2);
% 
% sideAi = sideAi';
% sideBi = sideBi';
% sideCi = sideCi';
% sideDi = sideDi';
% 
% sideAp = sideAp';
% sideBp = sideBp';
% sideCp = sideCp';
% sideDp = sideDp';
% 
% save('R_img4_A.dat', 'sideAi', '-ascii');
% save('R_img4_B.dat', 'sideBi', '-ascii');
% save('R_img4_C.dat', 'sideCi', '-ascii');
% save('R_img4_D.dat', 'sideDi', '-ascii');
% 
% save('R_pre2_A.dat', 'sideAp', '-ascii');
% save('R_pre2_B.dat', 'sideBp', '-ascii');
% save('R_pre2_C.dat', 'sideCp', '-ascii');
% save('R_pre2_D.dat', 'sideDp', '-ascii');
% 
% save('spp1.dat', 'spp1', '-ascii');
% save('spp2.dat', 'spp2', '-ascii');
% save('upp1.dat', 'upp1', '-ascii');
% save('upp2.dat', 'upp2', '-ascii');
% 
% sideA = sideA';
% sideB = sideB';
% sideC = sideC';
% sideD = sideD';
% save('R_A.dat', 'sideA', '-ascii');
% save('R_B.dat', 'sideB', '-ascii');
% save('R_C.dat', 'sideC', '-ascii');
% save('R_D.dat', 'sideD', '-ascii');
% 







