function do_unstab_sample()


arc_length = evalin('base', 'arc_length');
d = evalin('base', 'd');
a_min = evalin('base', 'a_min');
a_max = evalin('base', 'a_max');
Da_min = evalin('base', 'Da_min');
Da_max = evalin('base', 'Da_max');
D_min = evalin('base', 'D_min');
cB = evalin('base', 'cB');


% modified Ikeda map
param = {1, 0.9, 1, 0.4, 6};

% first saddle
p0 = [1.08331887404 -2.4079634834];
[uf1, arc] = sc_unstable(@ikeda, p0, arc_length, d, a_min, a_max, Da_min, Da_max, D_min, cB, diverge, param{:});
[ub1, arc] = sc_unstable(@ikeda, p0, arc_length, -d, a_min, a_max, Da_min, Da_max, D_min, cB, diverge, param{:});

figure(1);
h = plot(uf1(:, 1), uf1(:, 2), 'r', ub1(:, 1), ub1(:, 2), 'r', p0(1), p0(2), 'g.');
set(h(3), 'MarkerSize', 20);


% second saddle
p0 = [0.510743848045130   0.273108380475811];
[uf2, arc] = sc_unstable(@ikeda, p0, arc_length, d, a_min, a_max, Da_min, Da_max, D_min, cB, diverge, param{:});
[ub2, arc] = sc_unstable(@ikeda, p0, arc_length, -d, a_min, a_max, Da_min, Da_max, D_min, cB, diverge, param{:});

figure(2);
h = plot(uf2(:, 1), uf2(:, 2), 'r', ub2(:, 1), ub2(:, 2), 'r', p0(1), p0(2), 'g.');
set(h(3), 'MarkerSize', 20);


% non-invertible map
param = {-1.9, 0.1, 0.1, 0.1, 0.1};

p0 = [0 -1];
[uf, arc] = sc_unstable(@Lambda_noinv, p0, arc_length, d, a_min, a_max, Da_min, Da_max, D_min, cB, diverge, param{:});
[ub, arc] = sc_unstable(@Lambda_noinv, p0, arc_length, -d, a_min, a_max, Da_min, Da_max, D_min, cB, diverge, param{:});

figure(3);
h = plot(uf(:, 1), uf(:, 2), 'r', ub(:, 1), ub(:, 2), 'r', p0(1), p0(2), 'g.');
set(h(3), 'MarkerSize', 20);


% cutting map
param = {2, 0.01, 1, 0.87};

p0 = [0.279309944449109 0.438332177937098];

[ufc, arc] = sc_unstable(@cutting_map, p0, 50, d, a_min, a_max, Da_min, Da_max, D_min, cB, diverge, param{:});
[ubc, arc] = sc_unstable(@cutting_map, p0, 50, -d, a_min, a_max, Da_min, Da_max, D_min, cB, diverge, param{:});

figure(4);
h = plot(ufc(:, 1), ufc(:, 2), 'r', ubc(:, 1), ubc(:, 2), 'r', p0(1), p0(2), 'g.');
set(h(3), 'MarkerSize', 20);


