function y = ecomodel(x, alpha, beta, gamma, xi, k, N, a0, a1, q0, q1)
%
% x(1) -> x, x(2) -> r
%

if (length(x) ~= 2)
    cprintf('err', 'ERROR: First argument must be a vector with 2 elements.\n');
    y = [];
    return;
else
    y(1) = (1 + alpha - N*a0*q0/2/gamma)*x(1) - alpha/k*x(1)^2 + N/2/gamma*(a0*q0 - a1*q1)*x(1)*x(2);
    y(2) = x(2)/(x(2) + (1 - x(2))*exp(beta*((a0^2*q0 - a1^2*q1)/4/gamma*x(1) - xi)));
end;
