function [x, stat] = iterate(fhandle, x0, iters, diverge, varargin)

%
% Iterate the function given number of times
%
% fhandle  - function (dynamical system) handle
% x0       - point to be iterated
% iters    - number of iterates
% diverge - limit for divergence to infinity
% varargin - cell array of the function parameters
%


stat = 0;

x = x0;
for i = 1:iters
    x = fhandle(x, varargin{:});
    if (abs(x) > diverge)
        stat = -1;
        %cprintf(get_colour('warn'), 'WARNING: during map iteration orbit diverges, stop.\n');
        return;
    end;
end